/**
 * Copyright (c) 2024 LOBA
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to
 * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
 * the Software, and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
 * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 * SPDX-License-Identifier: MIT
 * 
 * Contributors:
 *     [name] - [contribution]
 */

.button {

    &-icon {
        width: rem(48);
        height: rem(48);
        text-align: center;
        // font-size: rem(24);
        font-size: rem(16);
        color: var(--color-default-2);
        border-radius: rem(200);
        text-decoration: none;
        position: relative;
        display: flex;
        align-items: center;
        justify-content: center;
        border: 1px solid rgba(133, 127, 228, 0.2);
        cursor: pointer;
        background: transparent;
        transition: all 0.3s ease;

        &:hover {
            color: var(--white);
            border-color: var(--color-default-2);
        }

        &.active {
            background: radial-gradient(50% 50% at 50% 50%, rgba(171, 167, 238, 0.2) 0%, rgba(133, 127, 228, 0.2) 100%);

            &.favourite {
                background: radial-gradient(50% 50% at 50% 50%, rgba(247, 147, 30, 0.2) 0%, rgba(247, 147, 30, 0.2) 100%);
                border-color: var(--color-hover-icon);

                i {
                    color: var(--color-hover-icon);

                    &.icon-favourites-line {
                        &::before {
                            content: "\e904";
                        }
                    }

                }
            }

        }

        &.small-btn {
            width: rem(32);
            height: rem(32);
            font-size: rem(13);
        }
    }

    // sizes

    &-default {
        border: 0;
        padding: 0;
        width: max-content;
        text-decoration: none;
        font-size: rem(14);
        font-weight: 700;
        position: relative;
        background: linear-gradient(90deg, #F7931E 0%, #BE5001 50%, #F7931E 100%);
        box-shadow: 0px 20px 24px rgba(12, 8, 65, 0.2);
        background-size: 200%;
        background-position: 100%;
        box-shadow: 0px 20px 24px 0px #0C084133;
        display: flex;
        align-items: center;
        border-radius: rem(78);
        color: var(--white);
        transition: all 0.3s ease;

        .button-inner {
            box-shadow: inset 0px 0px 0px 1px transparent;
            display: flex;
            align-items: center;
            padding-right: rem(20);
            border-radius: rem(78);
            transition: all 0.3s ease;
            font-size: rem(14);
        }

        .button-inner span {
            width: rem(48);
            height: rem(48);
            display: flex;
            align-items: center;
            justify-content: center;
            color: var(--white);
            font-size: rem(9);
            border-radius: rem(24);
            border: 1px solid var(--color-hover-icon);
            box-shadow: 0px 0px 0px 0px var(--color-default-3) inset;
            margin-right: rem(12);
            transition: all 0.3s ease;
        }

        &:hover {
            background-position: 0;

            .button-inner {
                box-shadow: inset 0px 0px 0px 1px var(--color-hover-icon);
            }

            span {
                background: radial-gradient(50% 50% at 50% 50%, #F7921E 0%, #BE5102 100%);
            }
        }

        &.purple {
            background: linear-gradient(90deg, var(--color-default-5) 0%, rgba(11, 8, 62, 0) 50%, var(--color-default-5) 100%);
            background-size: 200%;
            background-position: 100%;

            span {
                border: 1px solid var(--color-default-6);
                box-shadow: 0px 0px 0px 0px var(--color-default-6) inset;
            }

            &:hover {
                background-position: 0;

                .button-inner {
                    box-shadow: inset 0px 0px 0px 1px var(--color-default-6);
                }

                span {
                    background: radial-gradient(50% 50% at 50% 50%, rgba(76, 66, 203, 0.6) 0%, rgba(11, 8, 62, 0.6) 100%);
                    box-shadow: 0px 0px 16px 0px #0B083E inset;
                }
            }
        }
    }

    .icon-add {
        font-size: rem(14) !important;
    }

    &-medium {
        display: block;
        min-height: rem(56);
        line-height: rem(56);
        width: max-content;
        padding: rem(0) rem(24);
        text-decoration: none;
        font-size: rem(13);
        font-weight: 600;
    }

    &-medium-text {
        font-size: rem(16);
    }

    // colors

    &-secondary {
        padding: rem(16);
        display: block;
        border-radius: rem(31);
        box-shadow: 0px 8px 16px 0px #7090B01F;
        font-size: rem(14) !important;
        line-height: rem(14);
        color: var(--white);
        font-weight: 600;
        text-decoration: none;
        transition: all 0.3s ease;

        &.orange {
            border: 1px solid var(--color-hover-icon);
            background: radial-gradient(50% 50% at 50% 50%, rgba(247, 147, 30, 0.6) 0%, rgba(190, 80, 1, 0.6) 100%);

            &:hover {
                background: radial-gradient(50% 50% at 50% 50%, rgba(247, 147, 30, 0.8) 0%, rgba(190, 80, 1, 0.8) 100%);
            }
        }

        &.purple {
            border: 1px solid var(--color-default-2);
            background: radial-gradient(50% 50% at 50% 50%, rgba(171, 167, 238, 0.6) 0%, rgba(133, 127, 228, 0.6) 100%);

            &:hover {
                background: radial-gradient(50% 50% at 50% 50%, rgba(171, 167, 238, 0.8) 0%, rgba(133, 127, 228, 0.8) 100%);
            }
        }
    }

    &-simple {
        padding: rem(16);
        display: block;
        border-radius: rem(31);
        font-size: rem(14) !important;
        line-height: rem(14);
        color: var(--color-default-1);
        font-weight: 600;
        border: 1px solid rgba(133, 127, 228, 0.2);
        text-decoration: none;
        transition: all 0.3s ease;

        &:hover {
            border-color: rgba(133, 127, 228, 1);
            color: var(--white);
        }
    }

    &-black {
        background-color: var(--black);
        color: var(--white);
    }

    &-grey {
        background-color: var(--light-gray);
        color: var(--recent-grey-title);
    }

    &-grey-transparent {
        color: var(--black-op-04);
        border: rem(1) solid var(--button-grey);
    }

    &-black-transparent {
        color: var(--black);
        border: rem(1) solid var(--black);

        &:hover {
            background-color: var(--black);
            color: var(--white);
        }

    }

    &-orange {
        background: radial-gradient(50% 50% at 50% 50%, rgba(247, 147, 30, 0.6) 0%, rgba(190, 80, 1, 0.6) 100%);
        border: rem(1) solid var(--color-hover-icon);
        box-shadow: rem(0) rem(8) rem(16) rgba(112, 144, 176, 0.12);
        border-radius: rem(30);
        color: var(--white);
        padding: 0 rem(20);
        min-height: rem(48);
        line-height: rem(48);
        font-size: rem(14);

        &:hover {
            background: radial-gradient(50% 50% at 50% 50%, rgba(247, 147, 30, 0.8) 0%, rgba(190, 80, 1, 0.8) 100%);
        }

    }



    // other options

    &.rounded {
        border-radius: rem(80) !important;
    }

    &.arrow {

        padding-right: rem(40);
        position: relative;

        i {
            font-size: rem(8);
            height: rem(8);
            width: rem(8);
            position: absolute;
            right: rem(16);
            top: 50%;
            transform: translateY(-50%);
        }

    }

    &.text-center {
        text-align: center;
    }

    &-full {
        width: 100%;
    }

    &-inline {
        display: inline-block;
    }

    &-stroke {
        display: block;
        min-height: rem(40);
        line-height: rem(16);
        width: max-content;
        padding: rem(12);
        text-decoration: none;
        font-size: rem(14);
        font-weight: 500;
        border: 1px solid var(--black-op-04);
        border-radius: 16px;
        color: var(--black);
    }

    &-arrow {
        width: rem(48);
        height: rem(48);
        border-radius: rem(200);
        display: flex;
        align-items: center;
        justify-content: center;
        border: 1px solid rgba(133, 127, 228, 0.2);
        box-shadow: none;
        font-size: rem(8);
        background: none;
        color: var(--color-default-2);
        transition: all 0.3s ease;

        &:hover {
            color: var(--white);
            border-color: var(--color-default-2);
            background: radial-gradient(50% 50% at 50% 50%, rgba(171, 167, 238, 0.2) 0%, rgba(133, 127, 228, 0.2) 100%);
            box-shadow: 0px 8px 16px 0px #7090B01F;
        }
    }

    &-stroke-transparent {
        display: block;
        text-decoration: none;
        font-size: rem(14);
        padding: rem(16);
        color: var(--color-default-1);
        font-weight: 600;
        border-radius: rem(200);
        line-height: rem(14);
        border: 1px solid rgba(133, 127, 228, 0.2);
        transition: all 0.3s ease;
        background: transparent;

        &:hover {
            color: var(--white);
            border-color: var(--color-default-2);
        }
    }

    &-stroke-icon{
        display: block;
        text-decoration: none;
        font-size: rem(14);
        padding: rem(16);
        color: var(--color-default-1);
        font-weight: 600;
        border-radius: rem(200);
        line-height: rem(14);
        border: 1px solid rgba(133, 127, 228, 0.2);
        transition: all 0.3s ease;
        background: transparent;
        display: flex;
        align-items: center;
        gap: 10px;

        &:hover {
            color: var(--white);
            border-color: var(--color-hover-icon);
        }
    }

}